/*
 * socket.c
 *
 *  Created on: 12.11.2010
 *      Author: Arkadiusz Rawa
 */

#include "socket.h"

static int mySocket;
pthread_mutex_t mutex = PTHREAD_MUTEX_INITIALIZER;


int socket_connect(char* _port, char* _servername){
	char *servername, *port;
	int ret;
	servername = _servername;
	port = _port;

	struct addrinfo *addr_info, *p;
	struct addrinfo hints;

	memset(&hints, 0, sizeof(hints));
	hints.ai_family = AF_UNSPEC;
	hints.ai_socktype = SOCK_STREAM;
	hints.ai_protocol = IPPROTO_TCP;
	hints.ai_flags= 0;

	ret = getaddrinfo(servername, port, &hints, &addr_info);
	if(ret){
		printf("getinfo:%s\n", gai_strerror(ret));
		exit(1);
	}
	p = addr_info;
	
	while(p){
		mySocket = -1;
		char dst[INET6_ADDRSTRLEN];

		mySocket = socket(p->ai_family, p->ai_socktype, 0);

		getnameinfo(p->ai_addr, p->ai_addrlen, dst, 
				sizeof(dst), NULL,0, NI_NUMERICHOST);
		printf("Versuche zum Server: %s ...", dst);
		fflush(stdout);
		
		if(connect(mySocket, p->ai_addr, p->ai_addrlen) == 0){
			printf("Verbunden!!! \n");
		break;
		
		}else{
			perror("Fehlgeschlagen");		
		}
		
		close(mySocket);
		p= p->ai_next;
		
	}
	return mySocket;

}



int get_socket(){
	return mySocket;
}

pthread_mutex_t *get_send_mutex() {
	return &mutex;
}
