#ifndef CLIENT_H_
#define CLIENT_H_

 /****** Dipl.-Inform.(FH) Elias Drotleff / HS Ravensburg-Weingarten *******\
 *                                                                          *
 * Projekt:				Blackboard                          *
 *                                                                          *
 * Modulname:                           client                              *
 *                                                                          *
 * Modultyp:                            Funktionsbibliotek / Globale Daten  *
 *                                                                          *
 * Sprache:                             C                                   *
 *                                                                          *
 * Kurzbeschreibung:                    Hauptprogramm                       *
 *                                                                          *
 * Ersteller/Fach:      Elias Drotleff / Projektarbeit Sysop                *
 * Erstellungsdatum:	10.05.2007                                          *
 * letzte Aenderung:	11.03.2009                                          *
 *                                                                          *
 \**************************************************************************/

#include "../common/messages.h"

#define ERR_OOM -1
#define ERR_KILL_CLIENT -2


typedef struct {
	int s;
	t_msg_status status;
	char *board;
	char *name;
	uint8_t role;
	time_t last_update;
	
} global_client_state;

global_client_state GCS;


int updateGUIstate(void);
int __attribute__((cdecl)) start(int argc, char **argv);

void *gui_thread(void *data);
void sigint_handler(int sig);




#endif /*CLIENT_H_*/
