#include <stdlib.h>
#include <string.h>
#include <arpa/inet.h>
#include <unistd.h>
#include <errno.h>
#include "../common/sem.h"
#include "live.h"
#include "client.h"

void *live_thread(void *data) {
	t_msg_header hdr;
	hdr.type = RFC_BB_CONTENT;

	while(1) {
		if( sem_P(keymng_local(KEY_LIVE_SEM)) == -1 ) {
			if( errno == EIDRM ) return NULL;
		}

		hdr.length = htons(strlen(GCS.board));

		sem_P(keymng_local(KEY_GCSSOCK_SEM));

		send(GCS.s, &hdr, sizeof(t_msg_header), MSG_MORE);

		sem_P(keymng_local(KEY_GCS_SEM));
		send(GCS.s, GCS.board, strlen(GCS.board), 0);
		sem_V(keymng_local(KEY_GCS_SEM));

		sem_V(keymng_local(KEY_GCSSOCK_SEM));
	}

	return NULL;
}

