/*
 * $Id$
 */

#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <unistd.h>
#include <string.h>
#include <time.h>
#include "archive.h"
#include "../common/sem.h"
#include "../common/keymanager.h"
#include "../common/common.h"


void sigusr1_handler(int sig) {
	signal(sig, SIG_IGN);
	write_board_to_file("archive.txt");
	sem_V(keymng(KEY_ARC_SEM));
	signal(SIGUSR1, sigusr1_handler);
}

int archive(int test_interval) {
	signal(SIGUSR1, sigusr1_handler);

	while(1) {
		if(test_interval > 0) {
			sleep(test_interval);
			write_board_to_file("debug_archive.txt");
		} else {
			pause();
		}
	}

	return 0;
}

void write_board_to_file(char *filename) {
	FILE *file = fopen(filename, "a");
	time_t ltime;
	time(&ltime);
	struct tm *Tm = localtime(&ltime);

	if(file == NULL) return;

	fprintf(file, "%d:%d:%d:\n", Tm->tm_hour, Tm->tm_min, Tm->tm_min);
	fwrite(Board, strlen(Board), 1, file);
	fprintf(file, "\n=========\n");

	fclose(file);
}
