/* 
 * $Id: broadcastagent.mod.c 97 2011-01-28 11:32:53Z merkelt $
 */

#include <string.h>
#include <stdlib.h>
#include <arpa/inet.h>
#include <errno.h>
#include "broadcastagent.mod.h"
#include "clientlist.mod.h"
#include "client.mod.h"
#include "../common/messages.h"
#include "../common/common.h"
#include "../common/sem.h"


void *bcaThread(void *data) {
	client *c;
	t_msg_header hdr;
	t_msg_status status;
	uint8_t doz;
	uint8_t tut;
	uint16_t stud;

	while(1) {
		/*  mutex lock and wait */
		if( sem_P(keymng(KEY_BCA_SEM)) == -1 ) { 
			if( errno == EIDRM ) return 0;
		}

		sem_P(keymng(KEY_SHM_SEM));

		doz  = clientlist_dozcount();
		tut  = clientlist_tutcount();
		stud = clientlist_studcount();

		sem_P(keymng(KEY_CLIENTLIST_SEM));
		c = clientlist_getroot();
		while(c != NULL) {
			/* status basteln */
			hdr.type   = RFC_STATUS;
			hdr.length = htons(sizeof(t_msg_status));
			status.role      = c->p->role & (~ RFC_ROLE_TUT);
			status.client_id = htons(c->p->client_id);
			status.write_per = client_has_write_permission(c->p, tut);
			status.doz       = doz;
			status.tut       = tut;
			status.stud      = htons(stud);

			send(c->p->sock, &hdr, sizeof(hdr), MSG_MORE);
			send(c->p->sock, &status, sizeof(status), 0);
			
			if(status.write_per && Board[0] != '\0') {
				if( c->p->first_send == 0 ) {
					c = c->next;
					continue;
				} else {
					c->p->first_send = 0;
				}
			}

			/* tafel baseln */
			hdr.type   = RFC_BB_CONTENT;
			hdr.length = htons(strlen(Board));
			
			send(c->p->sock, &hdr, sizeof(hdr), MSG_MORE);

			if( strlen(Board) > 0 )
				send(c->p->sock, Board, strlen(Board), 0);

			c = c->next;
		}
		sem_V(keymng(KEY_CLIENTLIST_SEM));
		sem_V(keymng(KEY_SHM_SEM));
	}

}
