#include "../common/common.h"
#include "shm.h"
#include "../common/mq.h"
#include "../common/keymanager.h"

int shm_create() {
	int id;

	id = shmget(keymng(KEY_SHM), 0, 0); // use known shared memory object
	if (id == -1) {
		id = shmget(keymng(KEY_SHM), sizeof(char)*BOARD_ROWS*BOARD_COLS+1, IPC_CREAT|IPC_EXCL|0600);
		if (id == -1) {
			LOG("Error to create Shared-Memory\n"); 
			return -1;
		}
	}
	return id;
}

void shm_init(char* address) {
	int i;
	for (i = 0; i < BOARD_ROWS * BOARD_COLS + 1; i++) {
		address[i] = '\0';
	}
}

int shm_remove(int shmid) {
	if (shmctl(shmid, IPC_RMID, NULL) == -1) {
		perror("shm");
 		printf("Error to delete Shared-Memory - Shared Memory Segment doesn't exists!\n"); 
		return -1;
	}
	printf("Shared Memory Segment deleted\n");
	return 0;
}

void* shm_attach(int shmid) {
	char* address;
	address = shmat(shmid, NULL, SHM_RND);
	if (address == (char *) -1) {
		LOG("Error to attach to Shared Memory\n");
		return NULL;
	} else return address;
} 

int shm_detach(void *address) {
	if (shmdt(address) == -1) {
		LOG("Error to deatach from Shared Memory Segments"); 
		return -1;
	} else return 0;
}


